﻿package {
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.errors.IllegalOperationError;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	
	
	[SWF(width = "800", height = "600", backgroundColor = "#0", frameRate = "60")]
	
	/**
	 * @author Lorenzo
	 * 
	 * chargement des données binaire d'une image avec un URLLoader et
	 * conversion en un DisplayObject.
	 * Ajout du DisplayObject sur la scene.
	 */
	public class ChargementBinaire_test1 extends Sprite {
		
		
		private var _php:String = "http://localhost/_progFlash/_flashdevelop/ChargementImagesParURLLoader/bin/php/test1.php?x="+Math.random();
		private var _loadImg:URLLoader;
		
		
		public function ChargementBinaire_test1():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			stage.scaleMode = "noScale";
			stage.align = "TL";
			
			_loadImg = new URLLoader();
			_loadImg.dataFormat = URLLoaderDataFormat.BINARY;
			_loadImg.addEventListener(Event.COMPLETE, evtLoadImgComplete);
			_loadImg.addEventListener(IOErrorEvent.IO_ERROR, evtLoadImgError);
			_loadImg.addEventListener(SecurityErrorEvent.SECURITY_ERROR, evtLoadImgError);
			_loadImg.load(new URLRequest(_php));
		}



		// -----------------------------------------------------------------------------------
		// EVENEMENTS
		// -----------------------------------------------------------------------------------
		
		// ---------------------- URLLoader ----------------------
		private function evtLoadImgError(ev:Event):void {
			trace("evtLoadImgError");
			// erreur de chargement des données binaire
		}
		
		private function evtLoadImgComplete(ev:Event):void {
			trace("evtLoadImgComplete");
			// chargement des données binaire réussi

			var baJpg:ByteArray = _loadImg.data;
			trace("baJpg.length = ", baJpg.length);

			// -------------------------------------
			var conversion:Loader = new Loader();
			conversion.contentLoaderInfo.addEventListener(Event.COMPLETE, evtConversionComplete);
			conversion.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, evtConversionIOError);

			try{
				conversion.loadBytes(baJpg);
			}catch (er:ArgumentError) {
				trace("ArgumentError : "+er.message);
			}catch (er:IllegalOperationError) {
				trace("IllegalOperationError : "+er.message);
			}catch (er:SecurityError) {
				trace("SecurityError : "+er.message);
			}
		}
		
		// ---------------------- LOADER ----------------------
		private function evtConversionIOError(ev:IOErrorEvent):void {
			// déclenché si les données binaires ne peuvent pas être recomposé
			// dans un des types supportés par flash (gif/png/jpg/swf)
			trace("evtConversionIOError : " + ev.text);
		}
		
		private function evtConversionComplete(ev:Event):void {
			// conversion des données binaires en un DisplayObject réussi
			this.addChild(ev.currentTarget.loader.content);
		}

	}
	
}