﻿package {
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.errors.IllegalOperationError;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.utils.Endian;
	
	
	[SWF(width = "800", height = "600", backgroundColor = "#454338", frameRate = "60")]
	
	/**
	 * chargement de données binaire avec un URLLoader :
	 * - poids de l'image en binaire
	 * - données binaire de l'image
	 * 
	 * conversion en un DisplayObject.
	 * Ajout du DisplayObject sur la scene.
	 * 
	 * @author Lorenzo
	 */
	public class ChargementBinaire_test2 extends Sprite {
		
		private var _php:String = "http://localhost/_progFlash/_flashdevelop/ChargementImagesParURLLoader/bin/php/test2.php?x="+Math.random();
		private var _loadImg:URLLoader;
		
		public function ChargementBinaire_test2():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			stage.scaleMode = "noScale";
			stage.align = "TL";
			
			_loadImg = new URLLoader();
			_loadImg.dataFormat = URLLoaderDataFormat.BINARY;
			_loadImg.addEventListener(Event.COMPLETE, evtLoadImgComplete);
			_loadImg.addEventListener(IOErrorEvent.IO_ERROR, evtLoadImgError);
			_loadImg.addEventListener(SecurityErrorEvent.SECURITY_ERROR, evtLoadImgError);
			_loadImg.load(new URLRequest(_php));
		}



		// -----------------------------------------------------------------------------------
		// EVENEMENTS
		// -----------------------------------------------------------------------------------
		
		// ---------------------- URLLoader ----------------------
		private function evtLoadImgError(ev:Event):void {
			trace("evtLoadImgError");
			// erreur de chargement des données binaire
		}
		
		private function evtLoadImgComplete(ev:Event):void {
			trace("evtLoadImgComplete");
			// chargement des données binaire réussi

			var ba:ByteArray = _loadImg.data;
			// définition de la position du bit de poids fort
			// http://fr.wikipedia.org/wiki/Endianness
			ba.endian = Endian.LITTLE_ENDIAN;

			// lecture du poids de l'image
			var jpgLength:uint = ba.readUnsignedInt();

			// ecriture des données binaires restantes dans un ByteArray
			var baJpg:ByteArray = new ByteArray();
			baJpg.writeBytes(ba, ba.position, jpgLength);
			trace("baJpg.length = ", baJpg.length);

			// -------------------------------------
			var conversion:Loader = new Loader();
			conversion.contentLoaderInfo.addEventListener(Event.COMPLETE, evtConversionComplete);
			conversion.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, evtConversionIOError);

			try{
				conversion.loadBytes(baJpg);
			}catch (er:ArgumentError) {
				trace("ArgumentError : "+er.message);
			}catch (er:IllegalOperationError) {
				trace("IllegalOperationError : "+er.message);
			}catch (er:SecurityError) {
				trace("SecurityError : "+er.message);
			}
		}
		
		// ---------------------- LOADER ----------------------
		private function evtConversionIOError(ev:IOErrorEvent):void {
			trace("evtConversionIOError : " + ev.text);
			// déclenché si les données binaires ne peuvent pas être recomposé
			// dans un des types supportés par flash (gif/png/jpg/swf)
		}
		
		private function evtConversionComplete(ev:Event):void {
			// conversion des données binaires en un DisplayObject réussi
			this.addChild(ev.currentTarget.loader.content);
		}
	}
	
}