﻿package {
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.errors.IllegalOperationError;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.utils.Endian;
	
	
	[SWF(width = "800", height = "600", backgroundColor = "#454338", frameRate = "60")]
	
	/**
	 * chargement des données binaires représentant des images (gif/jpg/png/swf) d'un script PHP qui
	 * place les données dans un ordre précis :
	 * -nombre d'images (apparait qu'une seule fois)
	 * -poids de l'image
	 * -données de l'image
	 * 
	 * 
	 * conversion en DisplayObject.
	 * Ajout des DisplayObject sur la scene.
	 * 
	 * @author Lorenzo
	 */
	public class ChargementBinaire_test3 extends Sprite {
		
		private var _totalImg:uint = 0;
		private var _tbImg:Array = new Array();
		private var _posX:uint = 0;
		private var _posY:uint = 0;
		private var _time:int = 0;
		private var _php:String = "http://localhost/_progFlash/_flashdevelop/ChargementImagesParURLLoader/bin/php/test3.php?x="+Math.random();
		
		
		
		public function ChargementBinaire_test3():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			stage.scaleMode = "noScale";
			stage.align = "TL";
			
			var loadGroupImg:URLLoader = new URLLoader();
			loadGroupImg.dataFormat = URLLoaderDataFormat.BINARY;
			loadGroupImg.addEventListener(Event.COMPLETE, evtLoadGroupImgComplete);
			loadGroupImg.addEventListener(IOErrorEvent.IO_ERROR, evtLoadGroupImgError);
			loadGroupImg.addEventListener(SecurityErrorEvent.SECURITY_ERROR, evtLoadGroupImgError);
			loadGroupImg.load(new URLRequest(_php));
			
			stage.addEventListener(Event.RESIZE, evtStageResize);
		}


		// -----------------------------------------------------------------------------------
		// EVENEMENTS
		// -----------------------------------------------------------------------------------
		
		
		private function evtStageResize(e:Event):void {
			if ( _tbImg.length && _totalImg == _tbImg.length ) {
				while (this.numChildren > 0 ) {
					this.removeChildAt(0);
				}
				_posX = 0;
				_posY = 0;
				for (var i:int = 0; i < _totalImg; i++) {
					var dob:DisplayObject = _tbImg[i] as DisplayObject;
					dob.x = _posX;
					dob.y = _posY;
					this.addChild(dob);
					_posX += dob.width;
					if ( (_posX + dob.width) > stage.stageWidth ) {
						_posX = 0;
						_posY += dob.height;
					}
				}
			}
		}
		
		// ---------------------- URLLoader ----------------------
		private function evtLoadGroupImgError(ev:Event):void {
			trace("evtLoadGroupImgError");
			// erreur de chargement des données binaire
		}
		
		private function evtLoadGroupImgComplete(ev:Event):void {
			trace("evtLoadGroupImgComplete");
			// chargement des données binaire réussi
			
			var loadGroupImg:URLLoader = (ev.currentTarget as URLLoader);
			var ba:ByteArray = loadGroupImg.data;
			// définition de la position du bit de poids fort
			// http://fr.wikipedia.org/wiki/Endianness
			ba.endian = Endian.BIG_ENDIAN;
			
			// lecture du nombre total d'images
			_totalImg = ba.readUnsignedInt();
			trace("_totalImg", _totalImg);
			
			
			while (ba.position < ba.length) {
				// lecture du poids de l'image courante
				var jpgLength:uint = ba.readUnsignedInt();

				// ecriture des données binaires de l'image courante dans un ByteArray
				var baJpg:ByteArray = new ByteArray();
				baJpg.writeBytes(ba, ba.position, jpgLength);
				ba.position += jpgLength;
			
				// -------------------------------------
				var conversion:Loader = new Loader();
				conversion.contentLoaderInfo.addEventListener(Event.COMPLETE, evtConversionComplete);
				conversion.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, evtConversionIOError);

				try{
					conversion.loadBytes(baJpg);
				}catch (er:ArgumentError) {
					trace("ArgumentError : "+er.message);
				}catch (er:IllegalOperationError) {
					trace("IllegalOperationError : "+er.message);
				}catch (er:SecurityError) {
					trace("SecurityError : "+er.message);
				}
			}
			
			// -------------------------------------
			loadGroupImg.data = null;
			loadGroupImg.removeEventListener(Event.COMPLETE, evtLoadGroupImgComplete);
			loadGroupImg.removeEventListener(IOErrorEvent.IO_ERROR, evtLoadGroupImgError);
			loadGroupImg.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, evtLoadGroupImgError);
			loadGroupImg = null;
		}
		
		// ---------------------- LOADER - conversion ----------------------
		private function evtConversionIOError(ev:IOErrorEvent):void {
			trace("evtConversionIOError : " + ev.text);
			// déclenché si les données binaires ne peuvent pas être recomposé
			// dans un des types supportés par flash (gif/png/jpg/swf)
            var conversion:Loader = ev.currentTarget.loader as Loader;
			conversion.contentLoaderInfo.removeEventListener(Event.COMPLETE, evtConversionComplete);
			conversion.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, evtConversionIOError);
			conversion = null;
		}
		
		private function evtConversionComplete(ev:Event):void {
			// conversion des données binaires en un DisplayObject réussi
            var conversion:Loader = ev.currentTarget.loader as Loader;
			var dob:DisplayObject = conversion.content as DisplayObject;
			dob.x = _posX;
			dob.y = _posY;
			this.addChild(dob);
			_tbImg.push(dob);
			_posX += dob.width;
			if ( (_posX + dob.width) > stage.stageWidth ) {
				_posX = 0;
				_posY += dob.height;
			}
			conversion.contentLoaderInfo.removeEventListener(Event.COMPLETE, evtConversionComplete);
			conversion.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, evtConversionIOError);
			conversion = null;
		}

	}
	
}